unit XControlAutoPlace;

interface

uses Windows, XClasses, XVisuals, XForms, XApplets, XFormAutoSize;

type
   XControlAutoPlacer = class
   private
     FExecuting : Boolean;
   protected
   public
      constructor Create;
      procedure Execute( Sender : TObject );
   end;

procedure UseControlAutoPlace;

var ControlAutoPlacer : XControlAutoPlacer;

implementation

procedure UseControlAutoPlace;
begin
   if ControlAutoPlacer <> nil then Exit;
   ControlAutoPlacer := XControlAutoPlacer.Create;
end;

constructor XControlAutoPlacer.Create;
begin
   inherited;
   UseFormAutoSize;
   GlobalFormsManager.On_AutoSizeForm := Execute;
end;

procedure XControlAutoPlacer.Execute( Sender : TObject );
var V : XVisual;
    Done, Changed : Boolean;
    I, J, M : Integer;
    C, C2 : XClass;
    E, E2 : XControl;
    F : XForm;
    R, R2 : TRect;
    A : Set of XAlign;
    Horz, Vert : Boolean;
begin
   if FExecuting then Exit;
   V := Sender as XVisual;
   if V is XForm then
      F := V as XForm
   else
   if V is XControl then
      F := (V as XControl).ParentForm
   else
      F := nil;
   M := 4;
   if F <> nil then
      M := F.Margin;
   Done := False;
   Changed := False;
   while not Done do
   begin
      Done := True;
      for I := 0 to V.ChildsCount - 1 do
      begin
         C := V.Childs[ I ];
         if C is XControl then
         begin
            E := C as XControl;
            if not E.Showing then
               continue;
            Execute( E );
            R := E.BoundsRect;
            if (R.Left < M) or (R.Top < M) then
            if E.Align = alNone then
            begin
               if R.Left < M then
               begin
                  R.Left := M;
                  R.Right := R.Left + E.Width;
               end;
               if R.Top < M then
               begin
                  R.Top := M;
                  R.Bottom := R.Top + E.Height;
               end;
               if (E.Left <> R.Left) or (E.Top <> R.Top)
               or (E.Width <> R.Right - R.Left)
               or (E.Height <> R.Bottom - R.Top) then
               begin
                 FExecuting := True;
                 E.BoundsRect := R;
                 FExecuting := False;
                 Changed := True;
                 Done := False;
               end;
            end;
            if E.Align = alNone then
            begin
               Dec( R.Left, M );
               Inc( R.Right, M );
               Dec( R.Top, M );
               Inc( R.Bottom, M );
            end;
            for J := 0 to V.ChildsCount - 1 do
            if I <> J then
            begin
               C2 := V.Childs[ J ];
               if C2 is XControl then
               begin
                  E2 := C2 as XControl;
                  if not E2.Showing then continue;
                  Execute( E2 );
                  R2 := E2.BoundsRect;
                  A := [ E.Align, E2.Align ];
                  Horz := ((R2.Left >= R.Left) and (R2.Left < R.Right)
                  or (R2.Right > R.Left) and (R2.Right <= R.Right)) and
                  not ((R2.Bottom <= R.Top) or (R2.Top >= R.Bottom));
                  Vert := (R2.Top >= R.Top) and (R2.Top < R.Bottom) and
                       not((R2.Right <= R.Left) or (R2.Left >= R.Right))
                       or (R2.Left = R2.Right);
                  if Horz and Vert and (A <> [alNone]) then
                  begin
                     A := A - [alNone];
                     if (alLeft in A) or (alRight in A) then
                        Vert := False;
                     if (alTop in A) or (alBottom in A) then
                        Horz := False;
                  end;
                  if Horz or Vert then
                  begin
                     if (Horz and not Vert) or
                        Horz and Vert and (R.Top = R2.Top) and (R.Left <> R2.Left) then
                     begin
                        if (E.Align <> alRight) and (E2.Align <> alLeft) then
                        begin
                           R2.Left := R.Right;
                           R2.Right := R.Left + E2.Width;
                        end;
                     end
                        else
                     if Vert then
                     begin
                        if (E.Align <> alBottom) and (E2.Align <> alTop) then
                        begin
                           R2.Top := R.Bottom;
                           R2.Bottom := R2.Top + E2.Height;
                        end;
                     end;
                     if (R2.Left <> E2.Left) or (R2.Top <> E2.Top) then
                     begin
                        FExecuting := True;
                        E2.BoundsRect := R2;
                        FExecuting := False;
                        Done := False;
                        Changed := True;
                        break;
                     end;
                  end;
               end;
            end;
            if Changed then break;
         end;
      end;
   end;
   FExecuting := True;
   FormAutoSizer.Execute( Sender );
   if V.Parent <> nil then
   if V.Parent is XForm then
      FormAutoSizer.Execute( V.Parent );
   FExecuting := False;
end;

end.
